; 
    include \masm32\include\masm32rt.inc
    .586
    include \masm32\macros\timers.asm
; 
nops MACRO i
    REPEAT i
        nop
    ENDM
ENDM
    .data
    .code
; 
start:
; 
    LOOP_COUNT equ 1000000
    REPEAT_COUNT equ 1000

    invoke Sleep,1000

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
        mov   ebx, REPEAT_COUNT
        align 16
      @@:
        sub   ebx, 1
        jnz   @B
    counter_end
    push  eax
    print "conditional jump back to aligned label : "
    pop   eax
    print ustr$(eax)," cycles",13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
        mov   ebx, REPEAT_COUNT
        align 16
        nops 15
      @@:
        sub   ebx, 1
        jnz   @B
    counter_end
    push  eax
    print "conditional jump back to misaligned label : "
    pop   eax
    print ustr$(eax)," cycles",13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
        jmp   @F
        align 16
      @@:
      ENDM
    counter_end
    push  eax
    print "jump forward to aligned label : "
    pop   eax
    print ustr$(eax)," cycles",13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      align 16
        nops 15
      REPEAT REPEAT_COUNT
        jmp   @F
        nops 14
      @@:
      ENDM
    counter_end
    push  eax
    print "jump forward to misaligned label : "
    pop   eax
    print ustr$(eax)," cycles",13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
        align 8
        call alignedproc
      ENDM
    counter_end
    push  eax
    print "call aligned procedure : "
    pop   eax
    print ustr$(eax)," cycles",13,10

    counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
      REPEAT REPEAT_COUNT
         align 8
         nops 3
         call misalignedproc
      ENDM
    counter_end
    push  eax
    print "call misaligned procedure : "
    pop   eax
    print ustr$(eax)," cycles",13,10

    mov eax, input("Press any key to exit...")
    exit
; 
align 16
alignedproc proc
    xor   eax, eax
    ret
alignedproc endp
align 16
nops 15
misalignedproc proc
    xor   eax, eax
    ret
misalignedproc endp
; 
end start